<?php

namespace app\admin\controller;

use app\BaseController;
use think\App;
use think\facade\Db;
use think\facade\Validate;

//业务企业
class Business extends Base
{

    //业务企业只能从供应商升级而来
    public function create()
    {
        $companyNo = makeNo("GS");
        $company = isset($this->post['company']) && $this->post['company'] !== "" ? trim($this->post['company']) : "";
        if ($company == "") {
            return error_show(1002, "参数company不能为空");
        }
        $type = isset($this->post['type']) && $this->post['type'] !== "" ? trim($this->post['type']) : "";
        if ($type == "") {
            return error_show(1002, "参数type不能为空");
        }
        $inv_code = isset($this->post['inv_code']) && $this->post['inv_code'] !== "" ? trim($this->post['inv_code']) : "";
        if ($inv_code == "") {
            return error_show(1002, "参数inv_code不能为空");
        }
        $inv_legaler = isset($this->post['inv_legaler']) && $this->post['inv_legaler'] !== "" ? trim($this->post['inv_legaler']) : "";
        if ($inv_legaler == "") {
            return error_show(1002, "参数inv_legaler不能为空");
        }
        $inv_time = isset($this->post['inv_time']) && $this->post['inv_time'] !== "" ? $this->post['inv_time'] : "";
        if ($inv_time == "") {
            return error_show(1005, '参数inv_time不能为空');
        }
        $inv_addr = isset($this->post['inv_addr']) && $this->post['inv_addr'] !== "" ? trim($this->post['inv_addr']) : "";
        if ($inv_addr == "") {
            return error_show(1002, "参数inv_addr不能为空");
        }
        $inv_bank = isset($this->post['inv_bank']) && $this->post['inv_bank'] !== "" ? trim($this->post['inv_bank']) : "";
        if ($inv_bank == "") {
            return error_show(1002, "参数inv_bank不能为空");
        }
        $inv_bankNo = isset($this->post['inv_bankNo']) && $this->post['inv_bankNo'] !== "" ? trim($this->post['inv_bankNo']) : "";
        if ($inv_bankNo == "") {
            return error_show(1002, "参数inv_bankNo不能为空");
        }
        $contactor = isset($this->post['contactor']) && $this->post['contactor'] !== "" ? trim($this->post['contactor']) : "";
        if ($contactor == "") {
            return error_show(1002, "参数contactor不能为空");
        }
        $mobile = isset($this->post['mobile']) && $this->post['mobile'] !== "" ? trim($this->post['mobile']) : "";
        if ($mobile == "") {
            return error_show(1002, "参数mobile不能为空");
        }
        $addr = isset($this->post['addr']) && $this->post['addr'] !== "" ? trim($this->post['addr']) : "";
        if ($addr == "") {
            return error_show(1002, "参数addr不能为空");
        }
        $inv_scope = isset($this->post['inv_scope']) && $this->post['inv_scope'] !== "" ? trim($this->post['inv_scope']) : "";
        if ($inv_scope == "") {
            return error_show(1002, "参数inv_scope不能为空");
        }
        $license_img = isset($this->post['license_img']) && $this->post['license_img'] !== "" ? trim($this->post['license_img']) : "";
        $token = isset($this->post['token']) && $this->post['token'] != '' ? trim($this->post['token']) : "";
        if ($token == '') {
            return error_show(105, "参数token不能为空");
        }
        $createrid = $this->uid;//isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $creater = $this->uname;//isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $status = isset($this->post['status']) && $this->post['status'] !== "" ? intval($this->post['status']) : "1";
        $data = [
            "company" => $company,
            "companyNo" => $companyNo,
            "inv_code" => $inv_code,
            "type" => $type,
            "inv_legaler" => $inv_legaler,
            "inv_time" => $inv_time,
            "inv_addr" => $inv_addr,
            "inv_bank" => $inv_bank,
            "inv_bankNo" => $inv_bankNo,
            "contactor" => $contactor,
            "mobile" => $mobile,
            "addr" => $addr,
            "creater" => $creater,
            "createrid" => $createrid,
            "inv_scope" => $inv_scope,
            "license_img" => $license_img,
            "status" => $status,
            "is_del" => 0,
            "addtime" => date("Y-m-d H:i:s"),
            "updatetime" => date("Y-m-d H:i:s")
        ];

        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('bCreate', $data);
        return json_show($rs['code'], $rs['message'], $rs['data']);

    }

    public function list()
    {
        $param = $this->request->only([
            'page' => 1,
            'size' => 10,
            'company' => '',
            'status' => '',
            'creater' => '',
            'start' => '',
            'end' => '',
            'company_name' => '',
        ], 'post', 'trim');
        $userCommon =\app\admin\common\User::getIns();
        $rs = $userCommon->handle('bGetList', $param);
        return json_show($rs['code'], $rs['message'], $rs['data']);
    }

    public function edit()
    {

        $param = $this->request->only(['id', 'inv_addr', 'inv_bank', 'inv_bankNo', 'invoice_mobile','invoice_title'], 'post', 'trim');

        $val = Validate::rule([
            'id' => 'require|number|gt:0',
            'inv_addr' => 'require|max:255',
            'inv_bank' => 'require|max:255',
            'inv_bankNo' => 'require|max:255',
            'invoice_mobile' => 'require|max:255',
            'invoice_title' => 'require|max:255',
        ]);

        if ($val->check($param) == false) return json_show(1005, $val->getError());
		$param['updatetime'] = date("Y-m-d H:i:s");
        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('bEdit', $param);
        return json_show($rs['code'], $rs['message'], $rs['data']);
    }

    public function del()
    {
        $param = $this->request->only(['id' => 0], 'post', 'trim');
        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('delete', [
            'ids' => [$param['id']],
            'type' => 1,
            'updater' => $this->uname,
            'updaterid' => $this->uid,
        ]);
        return json_show($rs['code'], $rs['message'], $rs['data']);
    }

    public function status()
    {
        $param = $this->request->only(['id', 'status'], 'post', 'trim');
        $val = Validate::rule([
            'id' => 'require|number|gt:0',
            'status|状态' => 'require|number|in:0,1'
        ]);
        if (!$val->check($param)) return json_show(1005, $val->getError());
        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('status', [
            'id' => $param['id'],
            'status' => $param['status'],
            'type' => 1,
            'updater' => $this->uname,
            'updaterid' => $this->uid,
        ]);
        return json_show($rs['code'], $rs['message'], $rs['data']);
    }

    public function info()
    {
        $param = $this->request->only(['companyNo'], 'post', 'trim');
        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('bInfo', $param);
        return json_show($rs['code'], $rs['message'], $rs['data']);
    }

    public function title()
    {
        $param = $this->request->only(['company_type' => '', 'status' => ''], 'post', 'trim');
        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('bTitle', $param);
        return json_show($rs['code'], $rs['message'], $rs['data']);
    }
}