<?php

namespace app\admin\controller;

use app\admin\model\ChangeLog;
use app\BaseController;
use think\App;
use think\facade\Db;

//客户的组织架构
class Customer extends Base
{
    public function __construct(App $app)
    {
        parent::__construct($app);
    }

    /*列表*/
    public function list()
    {

        $param = $this->request->filter('trim')->post();

        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('customer_org_list', $param);

        return json_show($rs['code'], $rs['message'], $rs['data']);
  }

    /*新建*/
    public function create()
    {
        $param = $this->request->filter('trim')->post();

        $param['uid'] = $this->uid;
        $param['uname'] = $this->uname;

        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('customer_org_create', $param);

        return json_show($rs['code'], $rs['message'], $rs['data']);

    }

    /*更新*/
    public function update()
    {

        $param = $this->request->filter('trim')->post();

        $param['uid'] = $this->uid;
        $param['uname'] = $this->uname;

        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('customer_org_update', $param);

        return json_show($rs['code'], $rs['message'], $rs['data']);

    }

    /*查询*/
    public function info()
    {
        $id = isset($this->post['id']) && $this->post['id'] !== "" ? intval($this->post['id']) : "";
        if ($id == "") {
            return error_show(1004, "公司客户不存在");
        }

        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('customer_org_info', ['id' => $id]);

        return json_show($rs['code'], $rs['message'], $rs['data']);

    }

    /*删除*/
    public function delete()
    {

        $id = $this->request->post('id/d', 0, 'trim');

        if ($id === 0) return json_show(1004, 'id不能为空');

        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('customer_org_delete', ['id' => $id]);

        return json_show($rs['code'], $rs['message'], $rs['data']);

    }

    public function status()
    {

        $param = $this->request->filter('trim')->post();

        $userCommon = \app\admin\common\User::getIns();
        $rs = $userCommon->handle('customer_org_status', $param);

        return json_show($rs['code'], $rs['message'], $rs['data']);

    }

}