<?php

namespace app\admin\controller;

use app\BaseController;
use think\App;
use think\facade\Db;

//金价
class Goldprice extends BaseController
{
    public $post="";
    public $gold=[
        1=>'18K',2=>'24K',3=>'白银'
    ];
    public $rate=[
       1=> 0,2=>1,3=>3,4=>5,5=>6,6=>9,7=>13
    ];
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->post=$this->request->post();
    }

    public function linst(){
        $data=[];
        foreach ($this->gold as $key=>$value){
            $v =[];
            $v['type']=$key;
            $v['type_cn']=$value;
            $data[]=$v;
        }
        return app_show(0,"获取成功",$data);
    }

    public function create(){
        $type = isset($this->post['type']) && $this->post['type'] !=="" ?intval($this->post['type']):"";
        if($type==""){
            return error_show(1002,"参数type不能为空");
        }
        $price = isset($this->post['price']) && $this->post['price'] !=="" ? floatval($this->post['price']):"";
        if($price==""){
            return error_show(1002,"参数price不能为空");
        }
        $token = isset($this->post['token'])&& $this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(105,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(1002,"创建人数据不存在");
        }
        $action_id= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $action_name= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"1";
        $data=[
            "type"=>$type,
            "price"=>$price,
            "action_name"=>$action_name,
            "action_id"=>$action_id,
            "status"=>$status,
            "is_del"=>0,
            "addtime"=>date("Y-m-d H:i:s")
        ];
        $datainfo = Db::name('gold_price1')->insert($data);
        if($datainfo){
            return error_show(0,"新建成功");
        }else{
            return error_show(1002,"新建失败");
        }
    }
    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']) :"1";
        $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']) :"10";
        $where =[["is_del","=",0]];
        $type = isset($this->post['type']) && $this->post['type'] !=="" ? trim($this->post['type']):"";
        if($type!=""){
            $where[]=['type',"=",$type];
        }
        $action_name= isset($this->post['action_name']) && $this->post['action_name'] !=="" ? trim($this->post['action_name']):"";
        if($action_name!=""){
            $where[]=['action_name',"like","%$action_name%"];
        }
        $start = isset($this->post['start']) && $this->post['start']!=="" ? $this->post['start']:"";
        if($start!==""){
            $where[]=['addtime',">=",date('Y-m-d H:i:s',strtotime($start))];
        }
        $end = isset($this->post['end']) && $this->post['end']!=="" ? $this->post['end']:"";
        if($end!==""){
            $where[]=['addtime',"<",date('Y-m-d H:i:s',strtotime($end)+24*3600)];
        }
        $count = Db::name('gold_price1') ->where($where)->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('gold_price1')->where($where)->page($page,$size)->order("addtime desc")->select();
        $data=[];
        foreach ($list as $value){
            $value['type_cn']=$this->gold[$value['type']];
            $data[]=$value;
        }
        return app_show(0,"获取成功",['list'=>$data,'count'=>$count,]);
    }

    public function del(){
        $id = $this->post['id'] && $this->post['id'] !=="" ? intval($this->post['id']) :"";
        if($id===""){
            return  error_show(1004,"参数id不能为空");
        }
        $str= Db::name('gold_price1')->where(['id'=>$id,'is_del'=>0])->find();
        if(empty($str)){
            return error_show(1002,"未找到数据");
        }
        $end = Db::name('gold_price1')->update(['id'=>$id,'is_del'=>1]);
        if($end){
            return error_show(0,"删除成功");
        }else{
            return error_show(1002,"删除失败");
        }
    }
    public function status(){
        $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']):"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $info =  Db::name("gold_price1")->where([["id","=",$id],["is_del","=",0]])->find();
        if(!$info){
            return error_show(1002,"未找到对应数据");
        }
        $status =  isset($this->post['status']) && $this->post['status']!==""? intval($this->post['status']):"";
        if($status===""){
            return error_show(1002,"参数status不能为空");
        }
        if(!in_array($status,[0,1])){
            return error_show(1002,"参数status无效");
        }
        $info['status']=$status;
        $msg = $status==1?"启用":"禁用";
        $update = Db::name("gold_price1")->save($info);
        return  $update? error_show(0,"{$msg}成功"):error_show(1004,"{$msg}失败");
    }
    public function edit(){
        $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']):"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $info = Db::name("gold_price1")->where(['id'=>$id,"is_del"=>0])->find();
        if($info==""){
            return error_show(1003,"未找到数据");
        }
//        $type = isset($this->post['type']) && $this->post['type'] !=="" ?trim($this->post['type']):"";
//        if($type==""){
//            return error_show(1002,"参数type不能为空");
//        }
        $price = isset($this->post['price']) && $this->post['price'] !=="" ? floatval($this->post['price']):"";
        if($price==""){
            return error_show(1002,"参数price不能为空");
        }
        $token = isset($this->post['token'])&& $this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(105,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(1002,"创建人数据不存在");
        }
        $action_id= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $action_name= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        //$status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"";
     $data=[
            "type"=>$info['type'],
            "price"=>$price,
            "action_name"=>$action_name,
            "action_id"=>$action_id,
            "status"=>1,
            "is_del"=>0,
            "addtime"=>date("Y-m-d H:i:s")
        ];
        $datainfo = Db::name('gold_price1')->insert($data);
        if($datainfo){
            return error_show(0,"新建成功");
        }else{
            return error_show(1002,"新建失败");
        }
    }

    public function lastlist(){
        $where = [['g.is_del', '=', 0]];
        $type = isset($this->post['type']) && $this->post['type'] != "" ? intval($this->post['type']) : "";
        if ($type !== "") {
            $where[] = ['g.type', '=', $type];
        }
        $company_name = isset($this->post['company_name']) && $this->post['company_name'] !== "" ? trim($this->post['company_name']) : "";
        if ($company_name !== "") $where[] = ["g.action_id", 'in', get_company_item_user_by_name($company_name)];

        $ids = Db::name("gold_price1")
            ->where(['is_del' => 0])
            ->group("type")
            ->column("max(id) as id");
        $where[] = ['g.id', 'in', $ids];
        $list = Db::name("gold_price1")
            ->alias('g')
            ->where($where)
            ->select()
            ->toArray();

        $all_createrid = array_column($list,'action_id');
        $item = get_company_name_by_uid($all_createrid);

        $data = [];
        foreach ($list as $value) {
            $value['type_cn'] = $this->gold[$value['type']];
            $value['company_name'] = $item[$value['action_id']]??'';
            $data[] = $value;
        }
        return app_show(0, "获取成功", $data);
    }

    public function ratelist(){
        $data =[];
        foreach ($this->rate as $key=>$value){
            $v =[];
            $v['rate_cn']=$key;
            $v['rate']=$value;
            $data[]=$v;
        }
        return app_show(0,"获取成功",$data);
    }
}