<?php
declare (strict_types = 1);

namespace app\bbc\model;

use app\admin\model\Brand;
use app\admin\model\Cat;
use app\admin\model\GoodBasic;use app\admin\model\GoodZixun;use app\admin\model\Platform;use app\admin\model\Unit;
use think\Model;
use think\model\concern\SoftDelete;

/**
 * @mixin \think\Model
 */
class BbcFill extends Model
{
	use SoftDelete;
   protected $createTime="addtime";
   protected $updateTime="updatetime";
   protected $deleteTime = 'delete_time';
   protected $hidden = ['delete_time'];
   static $status_cn=['待提交','待转单','部分转单','转单成功','取消转单'];
   protected $append=["status_cn","wtrans_num","good_img"];
   public function unitT(){
   	return $this->belongsTo(Unit::class,"unit_id","id")->bind(["unit"]);
   }
   
   public function brand(){
   	return $this->belongsTo(Brand::class,'brand_id','id')->bind(['brand_name']);
   }
   
   public function cat(){
   	return $this->belongsTo(Cat::class,'cat_id','id')->bind(["cat_name"=>'search']);
   }
   
   public function platform(){
   	return $this->belongsTo(Platform::class,'platform_id','id')->bind(['platform_name']);
   }
   
   public function GetStatusCnAttr($v,$row){
   	    return self::$status_cn[$row['status']]??"";
   }
   
   public function GetGoodImgAttr($v,$row){
   	if($row['fill_type']==3)$img=(new GoodZixun())->where(["spuCode"=>$row['spuCode']])->value("good_img",'');
   	else $img=(new GoodBasic())->where(['spuCode'=>$row['spuCode']])->value('good_thumb_img','');
   	    return $img;
   }
   public function GetWtransNumAttr($v,$row){
   	    return  bcsub($row['good_num'],$row['transfer_num']);
   }
}
