<?php
declare (strict_types=1);

namespace app\command;

use app\admin\model\ActionLog;
use app\admin\model\GoodLog;
use app\admin\model\GoodStockInfo;
use app\admin\model\OrderImportFromC as OIFCModel;
use app\admin\model\OrderOutChild;
use app\admin\model\OrderTax;use app\admin\model\ProcessOrder;
use app\admin\model\SaleCgdPrice;use app\admin\model\Test1;
use think\console\Command;
use think\console\Input;
use think\console\input\Argument;
use think\console\input\Option;
use think\console\Output;
use think\facade\Cache;
use think\facade\Config;
use think\facade\Db;

//C端订单导入-处理
class ImportOrderFromCHandleData extends Command
{

    private $cgd_data = [];//存储采购单的数据，目前是为了做供应商api推送而准备的

    protected function configure()
    {
        // 指令配置
        $this->setName('handleData')
            ->setDescription('批量处理C端导入的订单数据');
    }

    //【脚本2】批量处理C端导入的订单数据
    protected function execute(Input $input, Output $output)
    {

        $key = 'import_order_from_c_key';
        $c_data_id = Cache::store('redis')->get($key);
		if($c_data_id==1)return '';
		Cache::store('redis')->set($key,1,180);
        $order_import_from_c_db = new OIFCModel();

        $c_data = $order_import_from_c_db
            ->where(['is_del' => OIFCModel::$is_del_normal, 'status' => OIFCModel::$status_wait_relation])
//                ->lock(true)
            ->field('id,createrid,creater')
            ->findOrEmpty()
            ->toArray();

        if (!empty($c_data)) {

            Db::startTrans();
            try {

                $standing_book_data = [];

                //先找用户确认信息
                $extend_data = Db::name('order_import_from_c_extend')
                    ->where(['order_import_from_c_id' => $c_data['id'], 'is_del' => 0, 'type' => 2])
                    ->find();
                if (empty($extend_data)) {
                    $extend_data = Db::name('order_import_from_c_extend')
                        ->where(['order_import_from_c_id' => $c_data['id'], 'is_del' => 0, 'type' => 1])
                        ->find();
                }

                if (empty($extend_data)) throw new \Exception('没有对应的解析数据');

                //复用sale::create()方法 -- start

                $orderCode = makeNo("QR");
                $customer_code = $extend_data['customer_code'];

                $customer = Db::connect('mysql_sys')
                    ->name("customer_info")
                    ->where(["companyNo" => $customer_code])
                    ->find();

                if ($customer == false) throw new \Exception('未找到客户数据');

                $supplierNo = $extend_data['companyNo'];
                $supplier = Db::connect('mysql_sys')
                    ->name("business")
                    ->where(["companyNo" => $supplierNo])
                    ->find();
                if ($supplier == false) throw new \Exception('未找到平台供应商数据');

                $goodtype = 1;//1正常商品

                $sendtype = 1;//直接发货
                $platform_id = $extend_data['platform_id'];
			$tmp = Db::name('platform')
            ->where(['is_del' => 0, 'id' => $extend_data['platform_id']])
            ->field('id,is_select_pay_rate,status')
            ->findOrEmpty();
        if (empty($tmp)) throw new \Exception('平台不存在');
        if ($tmp['status'] != 1) throw new \Exception('平台已禁用');
	    if($tmp['is_select_pay_rate']==1 && channel_is_company($extend_data['platform_id'],$supplierNo))throw new \Exception("平台渠道含有{$supplier['company']}");
                $platform_order = $extend_data['platform_code'];
                $good_num = $extend_data['num'];
                $arrtime = $extend_data['platform_time'];
                $paytime = $extend_data['addtime'];
                $workNo = $extend_data['po_code'];
                $ct = Db::name('good_platform')
                    ->alias('a')
                    ->join('good b', 'b.spuCode=a.spuCode', 'left')
                    ->where(['a.skuCode' => $extend_data['skuCode'], 'a.exam_status' =>3])//exam_status==3已上线
                    ->field("b.*,a.skuCode,a.spuCode,a.platform_code,a.plat_code")
                    ->find();
                if ($ct == false) throw new \Exception('未找到商品数据');

                $goodinfo = $ct;
                $is_stock = $ct['is_stock'];
                $order_type = $is_stock == 1 ? 1 : 2;//1备库(库存品)2非库存品
                $order_source = 4;//4平台
                $spuCode = $ct['spuCode'];
                $skuCode = $ct['skuCode'];
                $is_activity = empty($extend_data['activity_name']) ? 0 : 1;
                $origin = Db::name('good_nake')
                        ->where([['spuCode', '=', $spuCode], ['min_num', '<=', $good_num], ['is_del', '=', 0]])
                        ->order('min_num desc')
                        ->find();
                
                $origin_price = $goodinfo['is_stock'] == 1?0:($origin['nake_total']??0);
                $cgd_origin_price = $origin['supplier_origin_price']??0;
                if ($goodinfo['is_stock'] == 1) {
                    if ($ct['usable_stock'] < $good_num) {
                        throw new \Exception('商品库存数量不足');
                    }
                    
                }else{
                	if ($origin == false) throw new \Exception('未找到相关成本价格');
                }

                $sale_price = $extend_data['price'];
                if ($goodtype == 1) {
                    $good = Db::name("good_ladder")
                        ->where(["skuCode" => $skuCode, "is_del" => 0, "status" => 1])
                        ->where([["min_num", "<=", $good_num]])
                        ->order("min_num desc")
                        ->find();
                    if ($good == false) throw new \Exception('未找到相关阶梯价格');

                    //$sale_price = $good['sale_price']; //不改动售价

                    //理论上不会出现实时金价的订单
                    if ($ct['is_gold_price'] == 1 && $is_stock != 1) {
                        $gold = Db::name("gold_price1")
                            ->field('id,price')
                            ->where(["type" => $ct['noble_metal'], "is_del" => 0, "status" => 1])
                            ->order("addtime desc")
                            ->find();

                        //$saleprice(最终售价) = （打样费/购买数量 + 开模费/购买数量 + 商品重量* 最新金价 + 工艺费* 商品重量+包装费+加标费+证书费+产品裸价+物流费）/(1-成本售价/100);
                        $gold_sale_price = $ct['demo_fee'] / $good_num + $ct['open_fee'] / $good_num + $ct['noble_weight'] * $gold["price"] + $good['cost_fee'] * $ct['noble_weight'] + $origin['package_fee'] + $origin['mark_fee'] + $origin['cert_fee'] + $origin['nake_fee'] + $origin['delivery_fee'];
                        if ($sale_price < $gold_sale_price) throw new \Exception('价格不符合根据实时金价计算出的最终售价');

                        $ct['cgd_gold_price'] = $gold['price'];

//                $order_rate = Db::name("cat")->where(["id" => $ct['cat_id']])->value('order_rate');
//                $budget = isset($order_rate) ? $order_rate / 100 : 0;

                        // $saleprice = $total_fee / (1 - $budget);
                    }

                    if ($is_activity == 1) {
                        $act = Db::name("activity_info")
                            ->alias("a")
                            ->leftJoin("good_activity b", "a.activity_code=b.activity_code")
                            ->where(["a.skuCode" => $skuCode, "a.activity_code" => $extend_data['activity_code'], "a.is_del" => 0, "a.status" => 1, "b.status" => 6, "b.is_del" => 0])
                            ->find();
                        if ($act == false) throw new \Exception('未找到相关活动价');
                        if ($act['moq_num'] > $good_num) throw new \Exception('商品不满足活动价起订量' . $act['moq_num']);
                        if ($act['activity_stock'] < $good_num) throw new \Exception('商品活动库存剩余' . $act['activity_stock']);
                        //$sale_price = $act['activity_price'];//不能改动价格
                    }
                }
                $supplier_temp_info = Db::connect('mysql_sys')
                    ->name('supplier')
                    ->field('id,name,person,personid')
                    ->where('code', $ct['supplierNo'])
                    ->findOrEmpty();
                $cgd = [
                    "supplierNo" => $ct['supplierNo'],
                    "supplier_name" => $supplier_temp_info['name'],
                    "companyNo" => $supplierNo,
                    "companyName" => $supplier['company'],
                    "orderCode" => $orderCode,
                    "spuCode" => $ct['spuCode'],
                    "skuCode" => $ct['skuCode'],
                    "good_name" => $ct['good_name'],
                    "sale_price" => $origin_price,
                    "total_fee" => $origin_price * $good_num,
                    'origin_total' => $origin_price * $good_num,
                    "pakge_fee" => isset($origin['package_fee']) ? $origin['package_fee'] : 0,
                    "cert_fee" => isset($origin['cert_fee']) ? $origin['cert_fee'] : 0,
                    "open_fee" => $ct['open_fee'],
                    "cost_fee" => isset($origin['cost_fee']) ? $origin['cost_fee'] : 0,
                    "mark_fee" => isset($origin['mark_fee']) ? $origin['mark_fee'] : 0,
                    "demo_fee" => $ct['demo_fee'],
                    "nake_fee" => isset($origin['nake_fee']) ? $origin['nake_fee'] : 0,
                    "delivery_fee" => isset($origin['delivery_fee']) ? $origin['delivery_fee'] : 0,
                    "good_num" => $good_num,
                    "good_type" => $goodtype,
                    "order_type" => $order_type,
                    "order_source" => $order_source,
                    "createrid" => $supplier_temp_info['personid'],
                    "creater" => $supplier_temp_info['person'],
                    'send_way' => 2,
                    'gold_price' => $ct['cgd_gold_price'],
                    'good_createrid' => $goodinfo['createrid'],
                    'good_creater' => $goodinfo['creater'],//商品创建人
                    "weight" => $ct['noble_weight'],
                    'supplier_origin_price'=>$cgd_origin_price,//供应商采购成本
			        'cgd_supplier_code'=>$goodinfo['cgd_supplier_code'],//采购供应商编号
			        'cgd_supplier_name'=>$goodinfo['cgd_supplier_name'],//采购供应商编号
			        'cgd_apply_id'=>$goodinfo['cgd_apply_id'],//竞单人
			        'cgd_apply_name'=>$goodinfo['cgd_apply_name'],//竞单人
                ];

                $send_num = $extend_data['num'];
                $remark = $extend_data['order_remark'];
                $rm = $c_data['createrid'];
                $ri = $c_data['creater'];
                $data = [
                    "orderCode" => $orderCode,
                    "good_code" => $spuCode,
                    "skuCode" => $skuCode,
                    "customer_code" => $customer_code,
                    "customerName" => $customer['companyName'],
                    "good_name" => isset($goodinfo['good_name']) && $goodinfo['good_name'] !== '' ? $goodinfo['good_name'] : '',
                    "good_num" => $good_num,
                    "cat_id" => $goodinfo['cat_id'],
                    "apply_id" => $rm,
                    "apply_name" => $ri,
                    "origin_price" => $origin_price,
                    "sale_price" => $sale_price,
                    "post_fee" => 0,
                    "status" => 0,
                    "send_num" => 0,
                    "wsend_num" => $good_num,
                    "send_status" => 1,
                    "good_type" => $goodtype,
                    "send_type" => $sendtype,
                    "supplierNo" =>$supplierNo,
                    "supplierName" => $supplier['company']??"",
                    "supNo" => $ct['supplierNo'],
                    "supName" =>$supplier_temp_info['name']??"",
                    "is_del" => 0,
                    "zxNo" => "",
                    "platform_order" => $platform_order,
                    "platform_id" => $platform_id,
                    "remark" => $remark,
                    "is_stock" => $is_stock,
                    "is_activity" => $is_activity === "" ? 0 : $is_activity,
                    'activity_code' => $extend_data['activity_code'],
                    "order_type" => $order_type,
                    "order_source" => $order_source,
//                "poNo"=>$poNo,
                    'good_weight' => $ct['weight'],
                    'gold_price' => $ct['cgd_gold_price'],
                    'cost_price' => $ct['cost_fee'],
                    'diff_weight' => 0,
                    'diff_fee' => 0,
                    "workNo" => $workNo,
                    "addtime" => date("Y-m-d H:i:s"),
                    "updatetime" => date("Y-m-d H:i:s"),
                    'total_price' => round($sale_price * $good_num, 2),
                    'cgderid' => $supplier_temp_info['personid'],
                    'cgder' => $supplier_temp_info['person'],//采购员(供应商负责人)
                    'good_createrid' => $goodinfo['createrid'],
                    'good_creater' => $goodinfo['creater'],//商品创建人
                    'manager'=>$ri,
                    'managerid'=>$rm,
                ];
                $paytime == "" ? "" : $data['paytime'] = $paytime;
                $datainfo = Db::name('sale')->insert($data, true);
                if ($datainfo > 0) {
                    if ($is_activity == 1) {
                        $actup = [
                            "activity_stock" => $act['activity_stock'] - $good_num,
                            "updatetime" => date("Y-m-d H:i:s")
                        ];
                        $actupp = Db::name("activity_info")
                            ->where(["skuCode" => $skuCode, "activity_code" => $extend_data['activity_code'], "is_del" => 0, "status" => 1])
                            ->save($actup);
                        if ($actupp == false) throw new \Exception('活动库存修改失败');

                    }

                    //补充台账数据
                    $standing_book_data = array_merge($standing_book_data, [
                        'orderCode' => $orderCode,
                        'spuCode' => $data['good_code'],
                        'skuCode' => $data['skuCode'],
                        'order_type' => $data['order_type'],
                        'order_source' => $data['order_source'],
                        'supplierNo' => $extend_data['supplierNo'],
                        'companyNo' => $extend_data['companyNo'],
                        'customer_code' => $data['customer_code'],
                    ]);
                    if ($is_stock == 0) {

                        //非库存品
                        $bol = $this->createCgd($cgd, $rm, $ri, $standing_book_data);
                        if ($bol == false) throw new \Exception('订单创建失败');

                    }
                    else {
                        //库存品
                        $stockUp = [
                            "usable_stock" => $ct['usable_stock'] - $good_num,
                            "updatetime" => date("Y-m-d H:i:s"),
                        ];
                        $update = Db::name("good")->where(["spuCode" => $ct['spuCode'], "usable_stock" => $ct['usable_stock']])->update($stockUp);
                        if ($update == false) {
                            throw new \Exception('商品更新可用库存失败');
                        }
					SaleCgdPrice::GetPrice($datainfo);
                    }
            $taxInfo = OrderTax::SpuCat( $spuCode);
           if (!empty($taxInfo)) {
              (new \app\admin\model\OrderTax)->saveAll(array_map(function ($item)use($orderCode){
                   $temp=[];
                   $temp['code']=$orderCode;
                   $temp['spuCode']=$item['spuCode'];
                   $temp['tax_code']=$item['cat_code'];
                   $temp['tax_name']=$item['cat_name'];
                    $temp['tax_short_name']=$item['short_name'];
                   $temp['inv_tax']=$item['tax'];
                   $temp['inv_good_name']=$item['inv_good_name'];
                   return $temp;
              },$taxInfo));
            }
                    if ($sendtype == 1) {
                        $temp = [
                            'orderCode' => $orderCode,
                            'contactor' => $extend_data['contactor'],
                            'mobile' => $extend_data['mobile'],
                            'addr' => $extend_data['addr'],
                            'addr_code' => $extend_data['addr_code'],
                            'customer_code' => $customer_code,
                            'receipt_quantity' => $extend_data['num'],//收货数量,
                            'post_fee' => 0,
                            'is_del' => 0,
                            'addtime' => date("Y-m-d H:i:s"),
                            'updatetime' => date("Y-m-d H:i:s"),
                            'arrive_time' => $arrtime,
                        ];
                        $vmp = Db::name('order_addr')->insert($temp, true);
                        if ($vmp > 0) {
                            $num = $extend_data['num'];
                            $outCode = makeNo("DF");
                            if ($is_stock != 1) {
                                $order = Db::name("order_num")
                                    ->where(["orderCode" => $orderCode, "status" => 1])
                                    ->find();
                                if ($order == false) throw new \Exception('未找到可以发货得采购单数据');
	                                $tep = [
	                                    "cgdNo" => $order['cgdNo'],
	                                    "outCode" => $outCode,
	                                    "send_num" => $num,
	                                    "status" => 1,
	                                    "addtime" => date("Y-m-d H:i:s"),
	                                    "updatetime" => date("Y-m-d H:i:s")
	                                ];
	                                $sen = Db::name("order_send")->save($tep);
	                                if ($sen == false) throw new \Exception('发货地址添加创建失败');

	                                $cgdinfo = Db::name("purchease_order")->where(["cgdNo" => $order['cgdNo']])->find();
	                                if ($cgdinfo == false) throw new \Exception('未匹配到采购数据');

                            	}

                            $out = [
                                "orderCode" => $orderCode,
                                "outCode" => $outCode,
                                "apply_id" => $rm,
                                "apply_name" => $ri,
                                "addrid" => $vmp,
                                "post_name" => "",
                                "post_code" => "",
                                "post_fee" => 0,
                                "sendtime" => date("Y-m-d H:i:s"),
                                "send_num" => $num,
                                "check_num" => 0,
                                "error_num" => 0,
                                "wsm_code" => $is_stock == 1 ? '' : $cgdinfo['wsm_code'],
                                "order_type" => $order_type,
                                "status" => $is_stock == 1 ? 1 : 0,
                                "send_status" => $is_stock == 1 ? 1 : 0,
                                "addtime" => date("Y-m-d H:i:s"),
                                "updatetime" => date("Y-m-d H:i:s")
                            ];
                            $ou = Db::name("order_out")->insertGetId($out);
                            if ($ou == false) throw new \Exception('发货地址添加创建失败');
                            else {
                            if($is_stock == 1)OrderOutChild::makeChild($outCode);//非库存品无法立即分单

                                //修改状态，添加待办
                                if ($is_stock == 1) {
                                    $roleid = Config('app.wsm_cgder_role');
                                    $uids = Db::name('user_role')
                                        ->where('is_del', 0)
                                        ->whereIn('roleid', $roleid)
                                        ->column('uid');
                                    $handle_user_list = implode(',', $uids);
                                }

                                //修改状态，添加待办
                                ActionLog::logAdd(['id' => $rm, 'nickname' => $ri], [
                                    "order_code" => $outCode,//出库单号
                                    "status" => 0,//这里的status是之前的值
                                    "action_remark" => '',//备注
                                    "action_type" => "create"//新建create，编辑edit，更改状态status
                                ], "CKD", 0, $out);

                                ProcessOrder::AddProcess(['id' => $rm, 'nickname' => $ri], [
                                    "order_type" => 'CKD',
                                    "order_code" => $outCode,//出库单号
                                    "order_id" => $ou,
                                    "order_status" => $is_stock == 1 ? 1 : 0,
                                    "before_status" => 0,
                                    'holder_id' => $rm,
                                    'handle_user_list' => $handle_user_list ?? ""
                                ]);

                                $standing_book_data['outCode'] = $outCode;
                            }
                        } else throw new \Exception('发货地址添加失败');
                    }
                }

                //复用sale::create()方法 -- end


	            //处理完成
	            $up= $order_import_from_c_db
		            ->where('id', $c_data['id'])
		            ->where(['is_del'=> OIFCModel::$is_del_normal,'status' => OIFCModel::$status_wait_relation])
		            ->save([
			            'status' => $order_import_from_c_db::$status_success,
			            'updatetime' => date('Y-m-d H:i:s'),
			            'remark' => '',
			            'updateid' => 0,
			            'updater' => 'system',
			            'orderCode' => $orderCode
		            ]);
	            if($up==false)throw new \Exception($c_data['id'].'处理失败');

                //维护台账记录
                Db::name('standing_book')->insert(array_merge($standing_book_data, ['addtime' => date('Y-m-d H:i:s'), 'updatetime' => date('Y-m-d H:i:s'), 'standBookNo' => makeNo("IO")]));

                //将采购单数据塞入到队列中
                if ($this->cgd_data) {
                    $push_data = json_encode([
                        'supplierNo' => $this->cgd_data['supplierNo'],
                        'type' => 1,//1销售订单(采销的采购单),2上线结果
                        'data' => [
                            'cgdNo' => $this->cgd_data['cgdNo'],
                            'spuCode' => $this->cgd_data['spuCode'],
                            'good_name' => $this->cgd_data['good_name'],
                            'good_num' => $this->cgd_data['good_num'],
                            'good_price' => $this->cgd_data['good_price'],
                            'total_fee' => $this->cgd_data['total_fee'],
                            'weight' => $this->cgd_data['weight'],
                            'addtime' => $this->cgd_data['addtime'],
                        ],
                    ], JSON_UNESCAPED_UNICODE);
//                        Cache::store("redis")->handler()->lPush(Config::get('app.abutment_queue'), $push_data);
                    }

                    Db::commit();

                $output->writeln(date('Y-m-d H:i:s') . '|处理成功');

                } catch (\Exception $exception) {
                    Db::rollback();
                    $order_import_from_c_db
                        ->where(['id' => $c_data['id'], 'status' => OIFCModel::$status_wait_relation])
                        ->save([
                            'status' => $order_import_from_c_db::$status_stock_not_enough,
                            'updatetime' => date('Y-m-d H:i:s'),
                            'remark' => $exception->getMessage(),
                            'updateid' => 0,
                            'updater' => 'system'
                        ]);
                    // 指令输出
                    $output->writeln(date('Y-m-d H:i:s') . '|处理失败，' . $exception->getMessage() . '|' . $exception->getFile() . '|' . $exception->getLine());
                }
            }
//        }
		Cache::store('redis')->set($key,0);
    }


    //创建采购单
    private function createCgd($data = [], $rm = '0', $ri = '', array &$standing_book_data = [])
    {
        $cgdCode = makeNo("CG");
//        $supplier = Db::name("supplier")->where(["code" => $data['supplierNo'], "is_del" => 0])->find();
//        if ($supplier == false) return false;

        $wsm = Db::name("warehouse_info")
            ->where(["supplierNo" => $data["supplierNo"], "companyNo" => $data['companyNo'], "is_del" => 0])
            ->find();
        if ($wsm == false) {
            $wsm_code = makeNo("WSM");
            $inwsm = [
                "wsm_code" => $wsm_code,
                "name" => $data['supplier_name'],
                "wsm_type" => 2,
                "supplierNo" => $data['supplierNo'],
                "addr" => "",
                "addrs_code" => "",
                "contactor" => 0,
                "contactor_name" => 0,
                "mobile" => "",
                "position" => "",
                "companyNo" => $data['companyNo'],
                "status" => 1,
                "is_del" => 0,
                "addtime" => date("Y-m-d H:i:s"),
                "updatetime" => date("Y-m-d H:i:s")
            ];
            $in = Db::name("warehouse_info")->insert($inwsm);
            if ($in == false) return false;

        } else {
            $wsm_code = $wsm['wsm_code'];
        }

        //判断该供应商是否开通了供应商账号
        $from_tag = checkHasAccountBySupplierNos([$data['supplierNo']]);

        $cg = [
            "cgdNo" => $cgdCode,
            "bkcode" => "",
            "wsm_code" => $wsm_code,
            "cgder" => $data['creater'],
            "cgder_id" => $data['createrid'],
            "spuCode" => $data['spuCode'],
            "skuCode" => $data['skuCode'],
            "good_name" => $data['good_name'],
            "good_num" => $data['good_num'],
            "good_price" => $data['sale_price'],
            "total_fee" => round($data['sale_price'] * $data['good_num'], 2),
            "origin_total" => round($data['sale_price'] * $data['good_num'], 2),
            "pakge_fee" => $data['pakge_fee'],
            "cert_fee" => $data['cert_fee'],
            "open_fee" => $data['open_fee'],
            "teach_fee" => $data['cost_fee'],
            "mark_fee" => $data['mark_fee'],
            "demo_fee" => $data['demo_fee'],
            "nake_fee" => $data['nake_fee'],
            "delivery_fee" => $data['delivery_fee'],
            "weight" => $data['weight'],
            "diff_weight" => "0",
            "diff_fee" => "0",
            "gold_price" => $data['gold_price'],
            "supplierNo" => $data['supplierNo'],
            "supplier_name" => $data['supplier_name'],
            "companyNo" => $data['companyNo'],
            "companyName" => $data['companyName'],
            "send_status" => 1,
            "send_num" => 0,
            "wsend_num" => $data['good_num'],
            "remark" => "",
            "status" => 0,//0初始化
            "lasttime" => date("Y-m-d H:i:s"),
            "is_del" => 0,
            "open_type" => $data['open_type'],
            "order_type" => $data['order_type'],
            "order_source" => $data['order_source'],
            "good_type" => $data['good_type'],
            "addtime" => date("Y-m-d H:i:s"),
            'supplier_origin_price'=>$data["supplier_origin_price"],//供应商采购成本
	        'cgd_supplier_code'=>$data['cgd_supplier_code'],//采购供应商编号
	        'cgd_supplier_name'=>$data['cgd_supplier_name'],//采购供应商编号
	        'cgd_apply_id'=>$data['cgd_apply_id'],//竞单人
	        'cgd_apply_name'=>$data['cgd_apply_name'],//竞单人
            "updatetime" => date("Y-m-d H:i:s"),
            'good_createrid' => $data['good_createrid'],
            'good_creater' => $data['good_creater'],//商品创建人
            'from_tag' => isset($from_tag[$data['supplierNo']]) ? 2 : 1,//来源标签：1采销(默认),2供应商端
        ];
        $up = Db::name("purchease_order")->insert($cg, true);
        if ($up) {
            $taxInfo = OrderTax::SpuCat( $data['spuCode'],1,1);
           if (!empty($taxInfo)) {
              (new \app\admin\model\OrderTax)->saveAll(array_map(function ($item)use($cgdCode){
                   $temp=[];
                   $temp['code']=$cgdCode;
                   $temp['spuCode']=$item['spuCode'];
                   $temp['tax_code']=$item['cat_code'];
                   $temp['tax_name']=$item['cat_name'];
                    $temp['tax_short_name']=$item['short_name'];
                   $temp['inv_tax']=$item['tax'];
                   $temp['inv_good_name']=$item['inv_good_name'];
                   return $temp;
              },$taxInfo));
            }
            //修改状   态，添加待办
            ActionLog::logAdd(['id' => $rm, 'nickname' => $ri], [
                "order_code" => $cg['cgdNo'],//销售单code
                "status" => 0,//这里的status是之前的值
                "action_remark" => '',//备注
                "action_type" => "create"//新建create，编辑edit，更改状态status
            ], "CGD", $cg['status'], $cg);

            //当采购单是节点0待与供应商确认，推给供应商负责人
            ProcessOrder::AddProcess(['id' => $rm, 'nickname' => $ri], [
                "order_type" => 'CGD',
                "order_code" => $cg['cgdNo'],//销售单code
                "order_id" => $up,
                "order_status" => $cg['status'],
                "before_status" => 0,
                'holder_id' => $data['createrid'],
                'wait_id' => $data['createrid'],
                'wait_name' => $data['creater'],
            ]);

            $standing_book_data['cgdNo'] = $cgdCode;

            $rela = [
                "orderCode" => $data['orderCode'],
                "cgdNo" => $cgdCode,
                "spuCode" => $data['spuCode'],
                "good_num" => $data['good_num'],
                "wsend_num" => $data['good_num'],
                "send_num" => 0,
                "wait_num" => 0,
                "status" => 1,
                "source" => 2
            ];
            $re = Db::name("order_num")->save($rela);
            if ($re == false) return false;
            else {
                $stokc = Db::name("good_stock")
                    ->where(['spuCode' => $data['spuCode'], "wsm_code" => $wsm_code, "is_del" => 0])
                    ->find();
                if ($stokc == false) {
                    $stokc = [
                        "spuCode" => $data['spuCode'],
                        "wsm_code" => $wsm_code,
                        "wait_in_stock" => $data['good_num'],
                        "wait_out_stock" => 0,
                        "usable_stock" => 0,
                        "intra_stock" => 0,
                        "total_stock" => 0,
                        "status" => 1,
                        "addtime" => date("Y-m-d H:i:s"),
                        "updatetime" => date("Y-m-d H:i:s")
                    ];
                } else {
                    $stokc['wait_in_stock'] += $data['good_num'];
                    $stokc['updatetime'] = date("Y-m-d H:i:s");
                }
                $stoc = Db::name("good_stock")->save($stokc);
                if ($stoc == false) {
                    return false;
                }
                $good_data[] = ['good_log_code' => $cgdCode, "stock_id" => isset($stoc['id']) ? $stoc['id'] : Db::name("good_stock")->getLastInsID(), "type" => 1, 'stock' => $data['good_num'], "stock_name" => "wait_in_stock"];
                GoodLog::LogAdd(['id' => 0, 'nickname' => 'system'], $good_data, "CGD");

                $this->cgd_data = $cg;

                return true;
            }
        } else return false;

    }


    //创建.....
//    private function RelaCgd(array $outinfo = [], array &$standing_book_data = [])
//    {
//        //备库单
//        $cgd = Db::name("order_bk")
//            ->where([
//                ["spuCode", "=", $outinfo['spuCode']],
//                ["is_del", "=", 0],
//                ["balance_num", ">=", $outinfo['good_num']],
//                ['companyNo', "=", $outinfo['companyNo']]
//            ])
////            ->lock(true)
//            ->find();
//
//        if ($cgd == false) return false;
//
//        $cgdinfo = Db::name("purchease_order")
//            ->where(['cgdNo' => $cgd['cgdNo'], "is_del" => 0])
//            ->find();
//        if ($cgdinfo == false) return false;
//
//        //判断该供应商是否开通了供应商账号
//        $from_tag=checkHasAccountBySupplierNos([$cgdinfo['supplierNo']]);
//
//        $QrdCgd = [
//            "cgdNo" => makeNo("CG"),
//            "bkcode" => $cgdinfo['bkcode'],
//            'wsm_code' => $cgdinfo['wsm_code'],
//            "cgder_id" => $cgdinfo['cgder_id'],
//            "cgder" => $cgdinfo['cgder'],
//            "spuCode" => $cgdinfo['spuCode'],
//            "good_name" => $cgdinfo['good_name'],
//            "good_num" => $outinfo['good_num'],
//            "good_price" => $cgdinfo['good_price'],
//            "total_fee" => round($cgdinfo['good_price'] * $outinfo['good_num'], 2),
//            "pakge_fee" => $cgdinfo['pakge_fee'],
//            "cert_fee" => $cgdinfo['cert_fee'],
//            "open_fee" => $cgdinfo['open_fee'],
//            "delivery_fee" => $cgdinfo['delivery_fee'],
//            "mark_fee" => $cgdinfo['mark_fee'],
//            "teach_fee" => $cgdinfo['teach_fee'],
//            "nake_fee" => $cgdinfo['nake_fee'],
//            "demo_fee" => $cgdinfo['demo_fee'],
//            "weight" => $cgdinfo['weight'],
//            "diff_weight" => $cgdinfo['diff_weight'],
//            "diff_fee" => $cgdinfo['diff_fee'],
//            "gold_price" => $cgdinfo['gold_price'],
//            "supplierNo" => $cgdinfo['supplierNo'],
//            "supplier_name" => $cgdinfo['supplier_name'],
//            "companyNo" => $cgdinfo['companyNo'],
//            "companyName" => ,
//            "send_status" => 3,
//            "send_num" => $outinfo['good_num'],
//            "wsend_num" => 0,
//            "remark" => $cgdinfo['remark'],
//            "status" => 3,//入库完成
//            "lasttime" => $cgdinfo['lasttime'],
//            "is_del" => 0,
//            "order_type" => $outinfo['order_type'],
//            "order_source" => $outinfo['order_source'],
//            "good_type" => $cgdinfo['good_type'],
//            "addtime" => date("Y-m-d H:i:s"),
//            "updatetime" => date("Y-m-d H:i:s"),
//            'good_createrid' => $outinfo['good_createrid'],
//            'good_creater' => $outinfo['good_creater'],//商品创建人
//            'from_tag' => isset($from_tag[$cgdinfo['supplierNo']]) ? 2 : 1,//来源标签：1采销(默认),2供应商端
//        ];
//        $insetrCgd = Db::name("purchease_order")->insert($QrdCgd);
//        if ($insetrCgd == false) return false;
//
//        $standing_book_data = array_merge($standing_book_data, [
//            'cgdNo' => $QrdCgd['cgdNo'],
//            'bk_code' => $QrdCgd['bkcode'],
//        ]);
//
//        $merge_num = Db::name("purchease_order")
//            ->where(["bkcode" => $cgdinfo['bkcode'], "order_type" => $outinfo['order_type'], "is_del" => 0])
//            ->where('order_source', '<>', 0)//0备库单不计算在内
//            ->field("sum(send_num)-sum(th_num) as num")
//            ->find();
//        $cgd['balance_num'] = $cgd['total_num'] - $merge_num['num'];
//        $cgd['merge_num'] = $merge_num['num'];
//        $cgd['updatetime'] = date("Y-m-d H:i:s");
//        $up = Db::name("order_bk")->save($cgd);
//        if ($up == false) return false;
//
//        $data = [
//            "orderCode" => $outinfo['orderCode'],
//            "cgdNo" => $QrdCgd['cgdNo'],
//            "spuCode" => $outinfo['spuCode'],
//            "companyNo" => $outinfo['companyNo'],
//            "good_num" => $outinfo['good_num'],
//            "wsend_num" => $outinfo['good_num'],
//            "send_num" => 0,
//            "wait_num" => $outinfo['good_num'],
//            "status" => 1,
//            "source" => 1,
//        ];
//        $order = Db::name("order_num")->save($data);
//        if ($order == false) return false;
//
//        $this->cgd_data = $QrdCgd;
//        return true;
//    }


}
